=== debian/changelog ===
salmon (1.10.1+ds1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
    Closes: #1028713, #1031580
  * Refresh external files from pufferfish
  * Add autopkgtest

 -- Andreas Tille <tille@debian.org>  Mon, 13 Mar 2023 09:15:13 +0100
