## salmon 1.10.2+ds1

=== debian/changelog ===
salmon (1.10.2+ds1-1build3) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:26:44 +0200

salmon (1.10.2+ds1-1build2) noble; urgency=medium

  * Rebuild against new libstaden-read14t64.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 15 Apr 2024 12:58:19 +0200

salmon (1.10.2+ds1-1build1) noble; urgency=medium

  * No-change rebuild for boost defaults change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 15:55:37 +0100

salmon (1.10.2+ds1-1) unstable; urgency=medium

  * New upstream version
    Closes: #1043107
  * Standards-Version: 4.6.2 (routine-update)

 -- Michael R. Crusoe <crusoe@debian.org>  Wed, 16 Aug 2023 13:09:23 +0200
