=== debian/control ===
--- 
+++ 
@@ -36,7 +36,7 @@
                liblzma-dev,
                rapmap-dev,
                libsimde-dev
-Standards-Version: 4.6.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/salmon
 Vcs-Git: https://salsa.debian.org/med-team/salmon.git
 Homepage: https://github.com/COMBINE-lab/salmon
