=== debian/changelog ===
salmon (1.10.3+ds1-1) unstable; urgency=medium

  * Team upload.

  [ Santiago Vila ]
  * Fix FTBFS when using the nocheck build profile. Closes: #1103327.

  [ Yavor Doganov ]
  * New upstream release.
  * debian/control (Build-Depends): Add libparallel-hashmap-dev and stop
    using the bundled copy (Closes: #1088027).  Remove libspdlog-dev to
    avoid confusion; the package uses bundled ancient versions of spdlog
    and fmtlib so it needs porting.  Replace pkg-config with pkgconf.
    (Rules-Requires-Root): Remove; redundant.
    (Standards-Version): Claim compliance with 4.7.2; no changes needed.
  * debian/rules: Enable all hardening.
  * debian/external/pufferfish/include/libdivide/libdivide.h: Fix FTBFS
    with GCC 15 (Closes: #1097838).
  * debian/external/pufferfish/CMakeLists.txt: Remove useless CMake
    message which confuses blhc.
  * debian/patches/blhc.patch: Likewise.
  * debian/watch: Switch to version 5.
  * debian/copyright (Files-Excluded): Add include/parallel_hashmap.

 -- Yavor Doganov <yavor@gnu.org>  Wed, 12 Nov 2025 06:25:26 +0200
