=== debian/control ===
--- 
+++ 
@@ -13,17 +13,17 @@
                libboost-program-options-dev,
                libboost-timer-dev,
                libjellyfish-2.0-dev,
+               libparallel-hashmap-dev,
                libpthread-stubs0-dev,
                libsparsehash-dev,
                libdivsufsort-dev,
                libbwa-dev,
-               pkg-config,
+               pkgconf,
                libjemalloc-dev,
                libcereal-dev,
                libtbb-dev,
                libgff-dev (>> 2.0),
                libstaden-read-dev,
-               libspdlog-dev,
                libtclap-dev,
                help2man,
                sphinx-doc,
@@ -36,11 +36,10 @@
                liblzma-dev,
                rapmap-dev,
                libsimde-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/med-team/salmon
 Vcs-Git: https://salsa.debian.org/med-team/salmon.git
 Homepage: https://github.com/COMBINE-lab/salmon
-Rules-Requires-Root: no
 
 Package: salmon
 Architecture: any-amd64 arm64
