=== debian/rules ===
--- 
+++ 
@@ -4,8 +4,7 @@
 
 include /usr/share/dpkg/default.mk
 
-# Fails to build when trying to enhance hardening
-export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 CMAKE_EXTRA_FLAGS += -DCONDA_BUILD=1 \
                      -DFETCHED_RAPMAP=1 \
@@ -56,6 +55,10 @@
 	dh_auto_test --no-parallel
 endif
 
+override_dh_installexamples:
+	[ -d sample_data ] || tar xzvf sample_data.tgz
+	dh_installexamples
+
 override_dh_auto_clean:
 	dh_auto_clean
 	rm -rf external
