=== debian/watch ===
Version: 5

Template: Github
Compression: xz
Dversionmangle: s/[~\+]ds[0-9]*//
Owner: COMBINE-lab
Project: salmon
Repack: yes
Repacksuffix: +ds1
